#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=mkv.ico
#AutoIt3Wrapper_Outfile=MKVcleaver_x64.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Comment=This application is freeware.
#AutoIt3Wrapper_Res_Description=Extract all/any tracks from MKV files.
#AutoIt3Wrapper_Res_Fileversion=0.5.0.4
#AutoIt3Wrapper_Res_FileVersion_AutoIncrement=p
#AutoIt3Wrapper_Res_LegalCopyright=Ilia Bakhmoutski (sheck)
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Run_After="%scitedir%\AutoIt3Wrapper\ResHacker.exe" -add %out%, %out%, %scriptdir%\mkv.bmp, bitmap, LOGO, 0
#AutoIt3Wrapper_Run_After="%scitedir%\AutoIt3Wrapper\ResHacker.exe" -add %out%, %out%, %scriptdir%\line.bmp, bitmap, LINE, 0
#AutoIt3Wrapper_Run_After="%autoitdir%\Aut2Exe\upx.exe" --best --compress-resources=0 %out%
#AutoIt3Wrapper_Run_Tidy=y
#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/striponly
#AutoIt3Wrapper_Run_cvsWrapper=v
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <GuiListView.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <array.au3>
#include <file.au3>
#include <TreeViewConstants.au3>
#include <GuiTreeView.au3>
#include <GuiStatusBar.au3>
#include <Misc.au3>
#include <string.au3>
#include <resources.au3>
#include <Timers.au3>
#include <GuiComboBox.au3>
#include <GuiEdit.au3>

Opt("GUICloseOnESC", 0)
Opt("MustDeclareVars", 1)
AutoItSetOption("MouseCoordMode", 2)
OnAutoItExitRegister("OnAutoItExit")
HotKeySet("+!a", "SelectAll")
;HotKeySet("+!s", "_Source")

Global Const $WM_DROPFILES = 0x0233
Local $std, $szDrive, $szDir, $szFName, $szExt, $omit, $last_current, $all_checked = 0, $cmd, $output, $trackID[1], $path_array[1], $track_db[1][2], $v_max[1], $a_max[1], $s_max[1], $nMsg, $aDroppedFiles[1], $process_list, $cmd2
Local $full_path, $extract_attachments, $execute, $attachments, $chapters, $cuesheets, $tags, $timecodes, $cmd3, $multiplyer = 1, $call = 0, $no_execute = 0, $tc_only, $tc_with_tracks, $cancel = 0, $continue = 0, $h264, $file_split
Local $about_ok = 0x1, $about_gui, $std_mkvm, $identify_split[1], $version, $get_info, $statusbar, $mkvtlnix_path, $media_info_dll, $media_info_handle, $mkvinfo, $current, $selection_text, $logo, $IE, $Obj, $html, $codec_get_file
Local $files, $path_type, $path_split, $file_array, $file_format, $video_count, $audio_count, $subs_count, $split_path, $item, $v_codecs_string, $v_codec, $track_id, $track_id_split, $a_lng_string, $lng, $a_codecs_string, $a_codec
Local $s_lng_String, $s_codec, $s_codecs_string, $index, $info_edit, $file, $one_by_one, $del_index, $dir_select, $save_to, $destination, $file_total, $log_file, $child, $command, $tracklist_item, $fps, $return, $file_name, $new_ext
Local $identify, $sbText, $match, $extract_path, $attachID, $attach_filename, $extention_get, $return, $split_command, $track_index, $codec_id, $track_type, $track_num, $batch_item_split, $custom_extension, $find, $command_path
Local $timecodes_raw, $context_menu, $context_menu1, $avdump_split, $std_split, $curr_percent, $flac = 1, $atrack, $msg_now, $item_array[1][1], $no_toolnix = 0, $max_a, $max_s, $max_v, $number, $flac_flag, $flac = 1, $flac_flag = "--no-ogg "
Local $resize_bit = 0, $cursor, $detect_item, $text, $info, $timediff, $timer = 0, $extbt_en[1][2], $batch_item_db[1][2], $item_count, $button_state, $array_search1, $array_search2, $true, $nMsg_handle, $hl, $find_error, $codec_list
Local $sheck_link = 0x1, $autoit_link = 0x1, $mediainfo_link = 0x1, $avc2avi_link = 0x1, $avdump_link = 0x1, $mkvtoolnix_link = 0x1, $ogmcleaver_link = 0x1, $mkvcleaver_link = 0x1, $clean, $error_count = 0, $warning_count = 0
Local $find_warning, $max_log_size = 10240, $warning_log, $error_log, $last_error_count = 0, $last_warning_count, $channel_count, $omit_count = 0, $ext_list_item, $curr_codec, $last_codec, $last_ext, $curr_ext, $mkvex_version, $z = 0
Local $full_exec = 1, $vfr_detect = 1

$version = FileGetVersion(@AutoItExe)

If $CmdLine[0] > 0 Then
	If $CmdLine[1] = "--help" Or $CmdLine[1] = "-h" Or $CmdLine[1] = "/?" Or $CmdLine[1] = "/h" Or $CmdLine[1] = "/help" Or $CmdLine[1] = "help" Then
		MsgBox(0, "CMD Help", "MKVcleaver - version " & $version & @CR & _
				"Copyright 2010 - Ilia Bakhmoutski" & @CR & @CR & _
				'Usage: MKVcleaver.exe "path\file1.mkv" ["path\file2.mkv"] [...]')
		Exit
	EndIf
EndIf

Local $GUI = GUICreate("MKVcleaver " & $version, 733, 605, -1, -1, BitOR($WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX), $WS_EX_ACCEPTFILES)
Local $menu = GUICtrlCreateMenu("Settings")
Local $audio_menu = GUICtrlCreateMenu("Audio", $menu, 0)
Local $flac_raw = GUICtrlCreateMenuItem("Raw Flac", $audio_menu, 0, 1)
Local $flac_off = GUICtrlCreateMenuItem("Flac Inside Ogg", $audio_menu, 1, 1)
GUICtrlSetState($flac_raw, $GUI_CHECKED)
Local $tc_menu = GUICtrlCreateMenu("Timecodes", $menu, 1)
Local $tc_only = GUICtrlCreateMenuItem("Timecodes Only", $tc_menu, 0, 1)
Local $tc_with_tracks = GUICtrlCreateMenuItem("Timecodes With Tracks", $tc_menu, 1, 1)
GUICtrlSetState($tc_with_tracks, $GUI_CHECKED)
Local $resize_menu = GUICtrlCreateMenu("UI Resize", $menu, 2)
Local $resize_on = GUICtrlCreateMenuItem("On", $resize_menu, 0, 1)
Local $resize_off = GUICtrlCreateMenuItem("Off", $resize_menu, 1, 1)
GUICtrlSetState($resize_off, $GUI_CHECKED)
Local $lang_menu = GUICtrlCreateMenu("Track Language Code", $menu, 3)
Local $lang_on = GUICtrlCreateMenuItem("Append 2 Letter Lng Code", $lang_menu, 0, 1)
Local $lang_off = GUICtrlCreateMenuItem("Off", $lang_menu, 1, 1)
Local $sd_menu = GUICtrlCreateMenu("Shutdown PC", $menu, 4)
Local $sd_off = GUICtrlCreateMenuItem("Off", $sd_menu, 0, 1)
Local $sd_once = GUICtrlCreateMenuItem("Shutdown Just This Time", $sd_menu, 1, 1)
Local $sd_on = GUICtrlCreateMenuItem("Shutdown Every Time", $sd_menu, 2, 1)
Local $vfr_opt = GUICtrlCreateMenu("VFR Detection", $menu, 6)
Local $vfr_on = GUICtrlCreateMenuItem("On", $vfr_opt, 0, 1)
Local $vfr_off = GUICtrlCreateMenuItem("Off", $vfr_opt, 1, 1)
GUICtrlSetState($vfr_on, $GUI_CHECKED)
Local $tools_menu = GUICtrlCreateMenu("Tools")
Local $ext_edit = GUICtrlCreateMenuItem("Edit Extensions", $tools_menu, 0)
Local $codec_get = GUICtrlCreateMenuItem("Get Codec(s) From File", $tools_menu, 1)
;Local $sendtomenu = GUICtrlCreateMenu('Explorer "Send To" Menu', $menu, 5)
;Local $send_to = GUICtrlCreateMenuItem('Add To "Send To" Menu', $sendtomenu, 0)
;Local $send_to_remove = GUICtrlCreateMenuItem('Remove From "Send To" Menu', $sendtomenu, 1)
Local $help_menu = GUICtrlCreateMenu("Help")
Local $help = GUICtrlCreateMenuItem("Open Help File", $help_menu, 0)
Local $online_help = GUICtrlCreateMenuItem("Help Online", $help_menu, 1)
Local $online_forum = GUICtrlCreateMenuItem("Doom9 Forum", $help_menu, 2)
Local $email_me = GUICtrlCreateMenuItem("Email Author", $help_menu, 3)
Local $donate = GUICtrlCreateMenuItem("Donate", $help_menu, 4)
Local $ftp = GUICtrlCreateGroup("Files to process", 7, 8, 481, 450, -1)
GUICtrlSetColor(-1, 0x0000FF)
Local $removemkvs = GUICtrlCreateButton("Remove selected files from list", 247, 23, 231, 21, $WS_GROUP)
Local $file_list = GUICtrlCreateTreeView(18, 48, 459, 401, BitOR($TVS_HASBUTTONS, $TVS_HASLINES, $TVS_LINESATROOT, $TVS_CHECKBOXES, $TVS_NOHSCROLL, $TVS_SHOWSELALWAYS), $WS_EX_CLIENTEDGE + $WS_EX_ACCEPTFILES)
GUICtrlSetState($file_list, $GUI_DROPACCEPTED)
Local $open_mkvs = GUICtrlCreateButton("Open MKV files to process...", 17, 23, 227, 21, $WS_GROUP)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $od = GUICtrlCreateGroup("Output directory", 8, 467, 481, 53)
GUICtrlSetColor(-1, 0x0000FF)
Local $save_path_input = GUICtrlCreateInput("", 21, 487, 420, 21)
Local $save_path = GUICtrlCreateButton("...", 448, 485, 30, 24, $WS_GROUP)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Tracks to extract (Batch Mode)", 499, 41, 222, 280)
GUICtrlSetColor(-1, 0x0000FF)
Local $tracklist = GUICtrlCreateTreeView(509, 57, 202, 253, $TVS_CHECKBOXES, $WS_EX_CLIENTEDGE)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $toolnix_path = GUICtrlCreateButton("Locate MKVToolNix...", 499, 15, 125, 21, $WS_GROUP)
Local $about = GUICtrlCreateButton("About", 627, 15, 94, 21, $WS_GROUP)
GUICtrlCreateGroup("Filename options", 499, 326, 222, 81)
GUICtrlSetColor(-1, 0x0000FF)
Local $tr_fn_chk = GUICtrlCreateRadio("Track#_<filename>", 509, 342, 164, 19)
Local $lng_square = GUICtrlCreateLabel("", 705, 333, 14, 14)
Local $fn_tr_chk = GUICtrlCreateRadio("<filename>_Track#", 509, 359, 161, 19)
GUICtrlSetState($fn_tr_chk, $GUI_CHECKED)
Local $tropt_chk = GUICtrlCreateCheckbox("Use 'Video', 'Audio' and 'Subtitle'", 524, 381, 189, 16)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Video options", 499, 411, 222, 44)
GUICtrlSetColor(-1, 0x0000FF)
Local $cntoavi = GUICtrlCreateCheckbox("Convert H.264 tracks to AVI files", 509, 430, 200, 16)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $go = GUICtrlCreateButton("Extract Tracks !", 499, 471, 222, 48, $WS_GROUP)
$statusbar = _GUICtrlStatusBar_Create($GUI)
GUIRegisterMsg($WM_SIZE, "stb_resize")
GUIRegisterMsg($WM_DROPFILES, "WM_DROPFILES")
GUICtrlSetFont($file_list, 10, 800, 0, "Arial")
GUICtrlSetColor($file_list, 0x7b68ee)
GUICtrlSetFont($tracklist, 9, 800, 0, "Arial")
GUICtrlSetColor($tracklist, 0x7b68ee)
$info_edit = GUICtrlCreateEdit("", 18, 48, 459, 401, BitOR($ES_MULTILINE, $ES_READONLY, $WS_VSCROLL), $WS_EX_CLIENTEDGE)
GUICtrlSetColor(-1, 0x7b68ee)
GUICtrlSetState($info_edit, $GUI_HIDE)
GUICtrlSetResizing($info_edit, $GUI_DOCKAUTO)
GUICtrlSetResizing($lng_square, $GUI_DOCKAUTO)
GUICtrlSetResizing($open_mkvs, $GUI_DOCKAUTO)
GUICtrlSetResizing($removemkvs, $GUI_DOCKAUTO)
GUICtrlSetResizing($save_path_input, $GUI_DOCKAUTO + $GUI_DOCKHEIGHT)
;GUICtrlSetResizing($fo, $GUI_DOCKAUTO)
GUICtrlSetResizing($save_path, $GUI_DOCKAUTO + $GUI_DOCKHEIGHT)
GUICtrlSetResizing($about, $GUI_DOCKAUTO)
GUICtrlSetResizing($toolnix_path, $GUI_DOCKAUTO)
GUICtrlSetResizing($go, $GUI_DOCKHEIGHT + $GUI_DOCKAUTO)
GUICtrlSetResizing($cntoavi, $GUI_DOCKAUTO)
Local $lng_opt = IniRead(@ScriptDir & "\custom.ini", "Files", "Language", 0)
If $lng_opt = 0 Then
	GUICtrlSetState($lang_off, $GUI_CHECKED)
Else
	GUICtrlSetState($lang_on, $GUI_CHECKED)
EndIf
Local $sd = IniRead(@ScriptDir & "\custom.ini", "Shutdown Menu", "shutdown", 0)
Switch $sd
	Case 0
		GUICtrlSetState($sd_off, $GUI_CHECKED)
	Case 1
		GUICtrlSetState($sd_once, $GUI_CHECKED)
	Case 2
		GUICtrlSetState($sd_on, $GUI_CHECKED)
EndSwitch
Local $maximize = IniRead(@ScriptDir & "\custom.ini", "GUI", "maximized", 0)
Local $resize = IniRead(@ScriptDir & "\custom.ini", "GUI", "resize", 0)
Local $position = IniReadSection(@ScriptDir & "\custom.ini", "GUI")
If Not @error And $resize = 1 And $maximize = 0 Then
	WinMove("MKVcleaver " & FileGetVersion(@AutoItExe), "", $position[1][1], $position[2][1], $position[3][1], $position[4][1], 1)
	$resize_bit = 1
	GUICtrlSetState($resize_on, $GUI_CHECKED)
	GUICtrlSetState($resize_off, $GUI_UNCHECKED)
EndIf
$position = ""
If $resize = 1 And $maximize = 1 Then
	GUISetState(@SW_MAXIMIZE, $GUI)
	$resize_bit = 1
	GUICtrlSetState($resize_on, $GUI_CHECKED)
	GUICtrlSetState($resize_off, $GUI_UNCHECKED)
EndIf
GUICtrlSetState($go, $GUI_DISABLE)
GUICtrlSetState($removemkvs, $GUI_DISABLE)
$mkvtlnix_path = IniRead(@ScriptDir & "\custom.ini", "Mkvtlnix_Path", "path", "")
;If Not FileExists(@ScriptDir & "\avdump.exe") Or Not FileExists(@ScriptDir & "\avc2avi.exe") Then
;	FileInstall("avdump.exe", @ScriptDir & "\avdump.exe", 1)
;	FileInstall("avc2avi.exe", @ScriptDir & "\avc2avi.exe", 1)
;EndIf
;Local $dll_version = FileGetVersion(@ScriptDir & "\MediaInfo_x64.dll")
;$dll_version = StringMid($dll_version, 1, 1) & StringMid($dll_version, 3, 1) & StringMid($dll_version, 5, 2) & StringMid($dll_version, 8, 1)
;If $dll_version < "07330" Then FileInstall("MediaInfo_x64.dll", @ScriptDir & "\MediaInfo_x64.dll", 1)
;FileInstall("mkvcleaver_help.chm", @ScriptDir & "\MKVcleaver_Help.chm", 1)
$media_info_dll = DllOpen(@ScriptDir & "\MediaInfo_x64.dll")
If $media_info_dll = -1 Then
	OnAutoItExitUnregister("OnAutoItExit")
	MsgBox(16, "Error", "MKVcleaver was unable to load MediaInfo DLL." & @CRLF & @CRLF & "Reinstalling the application may fix the issue.")
	Exit
EndIf
$media_info_handle = DllCall($media_info_dll, "ptr", "MediaInfo_New")
If $mkvtlnix_path <> "" And Not FileExists($mkvtlnix_path & "\mkvextract.exe") Or $mkvtlnix_path <> "" And Not FileExists($mkvtlnix_path & "\mkvmerge.exe") Then
	MsgBox(48, "Warning", "Mkvextract.exe and/or Mkvmerge.exe was not found." & @CRLF & @CRLF & "Make sure that the path to the files is correct.")
	$no_toolnix = 1
ElseIf $mkvtlnix_path <> "" Then
	$mkvex_version = FileGetVersion($mkvtlnix_path & "\mkvextract.exe")
	If StringMid($mkvex_version, 1, 1) >= 4 Then
		GUICtrlSetState($audio_menu, $GUI_DISABLE)
		$flac_flag = ""
	EndIf
EndIf
$max_log_size = IniRead(@ScriptDir & "\custom.ini", "Files", "log_maxsize", $max_log_size)
GUISetState(@SW_SHOW)
If $CmdLine[0] > 0 Then
	For $a = 1 To $CmdLine[0]
		$files &= "|" & $CmdLine[$a]
	Next
	Add_Files($files)
	$files = ""
EndIf

While 1
	$nMsg = GUIGetMsg(1)
	$current = _GUICtrlTreeView_GetSelection($file_list)
	$selection_text = _GUICtrlTreeView_GetText($file_list, $current)
	If _ArraySearch($path_array, $selection_text, 1, 0, 0, 1) <> -1 And $current <> $last_current And $cancel = 0 Then
		_GUICtrlStatusBar_SetText($statusbar, $path_array[_ArraySearch($path_array, $selection_text, 1, 0, 0, 1)])
	EndIf
	$last_current = $current
	If $cancel = 1 Then $cancel = 0
	If $timer <> 0 And _Timer_Diff($timer) > 400 Then
		$timer = 0
		_Timer_KillTimer($GUI, $timer)
	EndIf
	Switch $nMsg[0]
		Case $GUI_EVENT_CLOSE
			If $nMsg[1] = $GUI Then Exit
			If $nMsg[1] = $about_gui Then GUISetState(@SW_HIDE, $about_gui)
		Case $about
			$about_gui = GUICreate("About MKVcleaver", 277, 310, -1, -1)
			GUICtrlCreateGroup("", 9, 8, 256, 251)
			GUICtrlCreateGroup("", 14, 90, 246, 164)
			GUICtrlCreateLabel("Product Name : ", 98, 26, 80, 17, $WS_GROUP)
			$mkvcleaver_link = GUICtrlCreateLabel("MKVcleaver", 178, 26, 60, 17, $WS_GROUP)
			GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			GUICtrlCreateLabel("Version : " & $version & " - 64 bit", 98, 49, 136, 17, $WS_GROUP)
			GUICtrlCreateLabel("License : GPL", 98, 71, 148, 17, $WS_GROUP)
			$logo = GUICtrlCreatePic("", 17, 23, 71, 63)
			_ResourceSetImageToCtrl($logo, "LOGO", $RT_BITMAP)
			GUICtrlCreateGroup("", -99, -99, 1, 1)
			GUICtrlCreateGroup("", -99, -99, 1, 1)
			GUICtrlCreateLabel("Author : Ilia Bakhmoutski", 17, 101, 130, 19)
			GUICtrlSetFont(-1, 9, 400, 0, "Times New Roman")
			$sheck_link = GUICtrlCreateLabel("(sheck)", 147, 101, 39, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			GUICtrlCreateLabel("Copyright : Ilia Bakhmoutski " & Chr(169) & " 2010", 17, 118, 188, 19)
			GUICtrlSetFont(-1, 9, 400, 0, "Times New Roman")
			GUICtrlCreateLabel("Source Language : ", 17, 135, 92, 19)
			GUICtrlSetFont(-1, 9, 400, 0, "Times New Roman")
			$autoit_link = GUICtrlCreateLabel("AutoIt v3", 106, 135, 52, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			GUICtrlCreateLabel("Reference Tools : ", 17, 152, 91, 19)
			GUICtrlSetFont(-1, 9, 400, 0, "Times New Roman")
			$ogmcleaver_link = GUICtrlCreateLabel("OGMcleaver", 106, 152, 67, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			$hl = GUICtrlCreatePic("", 17, 175, 240, 2)
			_ResourceSetImageToCtrl($hl, "LINE", $RT_BITMAP)
			GUICtrlCreateLabel("Additional Tools Used : ", 17, 182, 123, 19)
			GUICtrlSetFont(-1, 9, 400, 0, "Times New Roman")
			$mediainfo_link = GUICtrlCreateLabel("MediaInfoDLL", 139, 182, 78, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			$avdump_link = GUICtrlCreateLabel("Avdump", 139, 198, 47, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			$avc2avi_link = GUICtrlCreateLabel("Avc2Avi_mod", 139, 215, 75, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			$mkvtoolnix_link = GUICtrlCreateLabel("MkvToolNix", 139, 233, 68, 19)
			GUICtrlSetFont(-1, 9, 400, 4, "Times New Roman")
			GUICtrlSetColor(-1, 0x0000FF)
			GUICtrlSetCursor(-1, 0)
			GUICtrlCreateGroup("", -99, -99, 1, 1)
			$about_ok = GUICtrlCreateButton("&OK", 100, 271, 75, 25)
			GUISetState(@SW_SHOW)
		Case $sheck_link
			ShellExecute("http://www.autoitscript.com/forum/index.php?showuser=9851")
			GUICtrlSetColor($sheck_link, 0xBA75FF)
		Case $autoit_link
			ShellExecute("http://www.autoitscript.com/autoit3/")
			GUICtrlSetColor($autoit_link, 0xBA75FF)
		Case $ogmcleaver_link
			ShellExecute("http://sites.google.com/site/ogmcleaver/")
			GUICtrlSetColor($ogmcleaver_link, 0xBA75FF)
		Case $mediainfo_link
			ShellExecute("http://mediainfo.sourceforge.net/en/Download/Windows")
			GUICtrlSetColor($mediainfo_link, 0xBA75FF)
		Case $avdump_link
			ShellExecute("http://wiki.anidb.info/w/Avdump")
			GUICtrlSetColor($avdump_link, 0xBA75FF)
		Case $avc2avi_link
			ShellExecute("http://sourceforge.net/projects/avc2avi/")
			GUICtrlSetColor($avc2avi_link, 0xBA75FF)
		Case $mkvtoolnix_link
			ShellExecute("http://www.bunkus.org/videotools/mkvtoolnix/downloads.html")
			GUICtrlSetColor($mkvtoolnix_link, 0xBA75FF)
		Case $mkvcleaver_link
			ShellExecute("http://apps.einsof-haras.ca")
			GUICtrlSetColor($mkvcleaver_link, 0xBA75FF)
		Case $about_ok
			GUISetState(@SW_HIDE, $about_gui)
		Case $online_help
			ShellExecute("http://apps.einsof-haras.ca/mkvcleaver_howto.html")
		Case $donate
			ShellExecute("http://apps.einsof-haras.ca/donate.html")
		Case $help
			ShellExecute(@ScriptDir & "\MKVcleaver_help.chm")
		Case $online_forum
			ShellExecute("http://forum.doom9.org/showthread.php?t=152108")
		Case $email_me
			ShellExecute("mailto:sheck@einsof-haras.ca")
		Case $GUI_EVENT_DROPPED
			ContinueCase
		Case $open_mkvs
			If $nMsg[0] = $open_mkvs Then
				$files = FileOpenDialog("Select Files To Open", "", "Matroska (*.mkv; *.mka; *.mks; *.webm)|All (*.*)", 7)
				If @error Then ContinueLoop
				$file_array = StringSplit($files, "|")
				If UBound($file_array) - 1 > 1 Then
					$files = $file_array[1] & "\" & $file_array[2]
					For $a = 3 To UBound($file_array) - 1
						$files &= "|" & $file_array[1] & "\" & $file_array[$a]
					Next
				EndIf
				$file_array = ""
			ElseIf $nMsg[0] = $GUI_EVENT_DROPPED Then
				For $a = 1 To UBound($aDroppedFiles) - 1
					Select
						Case StringInStr(FileGetAttrib($aDroppedFiles[$a]), "D")
							$file_array = _FileListToArray($aDroppedFiles[$a], "*.mk*", 1)
							If StringMid($aDroppedFiles[$a], StringLen($aDroppedFiles[$a]), 1) = "\" Then $aDroppedFiles[$a] = StringTrimRight($aDroppedFiles[$a], 1)
							If $file_array <> 0 Then
								$files &= "|" & $aDroppedFiles[$a] & "\" & $file_array[1]
								For $b = 2 To UBound($file_array) - 1
									$files &= "|" & $aDroppedFiles[$a] & "\" & $file_array[$b]
								Next
							Else
								$files = ""
							EndIf
						Case Else
							$files &= "|" & $aDroppedFiles[$a]
					EndSelect
				Next
			EndIf
			Add_Files($files)
			$files = ""
		Case $removemkvs
			_GUICtrlTreeView_BeginUpdate($file_list)
			$find = _ArrayFindAll($item_array, "True", 1, 0, 0, 0, 1)
			For $a = 0 To UBound($find) - 1
				$one_by_one = _ArraySearch($item_array, "True", 1)
				$file = GUICtrlGetHandle($item_array[$one_by_one][0])
				$del_index = _ArraySearch($path_array, _GUICtrlTreeView_GetText($file_list, $file), 1, 0, 0, 1)
				_ArrayDelete($path_array, $del_index)
				_ArrayDelete($v_max, $del_index)
				_ArrayDelete($a_max, $del_index)
				_ArrayDelete($s_max, $del_index)
				_ArrayDelete($track_db, _ArraySearch($track_db, $file))
				_ArrayDelete($item_array, $one_by_one)
				_GUICtrlTreeView_Delete($file_list, $file)
			Next
			_GUICtrlTreeView_EndUpdate($file_list)
			_GUICtrlStatusBar_SetText($statusbar, "")
			If UBound($path_array) < 2 Then
				GUICtrlSetState($go, $GUI_DISABLE)
				_GUICtrlTreeView_DeleteAll($tracklist)
				Local $v_max[1], $a_max[1], $s_max[1], $track_db[1][2], $extbt_en[1][2], $item_array[1]
			Else
				_TrackCount_Update()
			EndIf
			GUICtrlSetState($removemkvs, $GUI_DISABLE)
		Case $toolnix_path
			$dir_select = FileSelectFolder("Point to MKVToolNix Folder", "", 6, "")
			If @error Then ContinueLoop
			If StringMid($dir_select, StringLen($dir_select), 1) = "\" Then $dir_select = StringTrimRight($dir_select, 1)
			$mkvtlnix_path = $dir_select
			IniWrite(@ScriptDir & "\custom.ini", "Mkvtlnix_Path", "path", $dir_select)
			If Not FileExists($mkvtlnix_path & "\mkvextract.exe") Or Not FileExists($mkvtlnix_path & "\mkvmerge.exe") Then
				MsgBox(48, "Warning", "Mkvextract.exe and/or Mkvmerge.exe was not found." & @CRLF & @CRLF & "Make sure that the path to the files is correct.")
				GUICtrlSetState($go, $GUI_DISABLE)
				$no_toolnix = 1
				ContinueLoop
			EndIf
			$no_toolnix = 0
			If _ArrayFindAll($extbt_en, "True", 1, 0, 0, 0, 1) <> -1 Then GUICtrlSetState($go, $GUI_ENABLE)
			$mkvex_version = FileGetVersion($mkvtlnix_path & "\mkvextract.exe")
			If StringMid($mkvex_version, 1, 1) >= 4 Then
				GUICtrlSetState($audio_menu, $GUI_DISABLE)
				GUICtrlSetState($flac_off, $GUI_CHECKED)
				GUICtrlSetState($flac_raw, $GUI_UNCHECKED)
				$flac_flag = ""
			Else
				GUICtrlSetState($audio_menu, $GUI_ENABLE)
			EndIf
		Case $save_path
			$save_to = FileSelectFolder("Select Output Directory", "", 6, "")
			If @error Then ContinueLoop
			GUICtrlSetData($save_path_input, $save_to)
		Case $tc_with_tracks
			$no_execute = 0
			GUICtrlSetState($tc_with_tracks, $GUI_CHECKED)
		Case $tc_only
			$no_execute = 1
			GUICtrlSetState($tc_only, $GUI_CHECKED)
		Case $flac_off
			$flac_flag = ""
			GUICtrlSetState($flac_off, $GUI_CHECKED)
			$flac = 0
		Case $flac_raw
			$flac_flag = "--no-ogg "
			GUICtrlSetState($flac_raw, $GUI_CHECKED)
			$flac = 1
		Case $resize_on
			$resize_bit = 1
			GUICtrlSetState($resize_on, $GUI_CHECKED)
		Case $resize_off
			$resize_bit = 0
			GUICtrlSetState($resize_off, $GUI_CHECKED)
		Case $sd_off
			$sd = 0
			IniWrite(@ScriptDir & "\custom.ini", "Shutdown Menu", "shutdown", 0)
		Case $sd_once
			$sd = 1
			IniWrite(@ScriptDir & "\custom.ini", "Shutdown Menu", "shutdown", 1)
		Case $sd_on
			$sd = 2
			IniWrite(@ScriptDir & "\custom.ini", "Shutdown Menu", "shutdown", 2)
		Case $vfr_on
			$vfr_detect = 1
			GUICtrlSetState($vfr_on, $GUI_CHECKED)
		Case $vfr_off
			$vfr_detect = 0
			GUICtrlSetState($vfr_off, $GUI_CHECKED)
			;		Case $send_to
			;			FileCreateShortcut(@AutoItExe, @UserProfileDir & "\SendTo\MKVcleaver.lnk", @ScriptDir, "", "Send mkv files to MKVcleaver", @AutoItExe, "", 0, @SW_SHOWNORMAL)
			;		Case $send_to_remove
			;			FileDelete(@UserProfileDir & "\SendTo\MKVcleaver.lnk")
		Case $codec_get
			$codec_get_file = FileOpenDialog("Select a MKV file.", "My Computer", "Matroska Files (*.mkv; *.mka; *.mks; *.webm) | All Files (*.*)", 3)
			If @error Then ContinueLoop
			$file_format = _Get_MediaInfo($codec_get_file, "File;%Format%")
			If Not $file_format = "Matroska" Then
				MsgBox(48, "Wrong File Format", "File was not recognized as Matroska.")
				ContinueLoop
			EndIf
			Local $codec_get_gui = GUICreate("Codec List", 393, 367, -1, -1)
			GUICtrlCreateGroup("Codec List", 10, 12, 372, 342)
			$codec_list = GUICtrlCreateListView("Extension|Codec", 22, 33, 347, 267, BitOR($LVS_EDITLABELS, $LVS_SINGLESEL, $LVS_SHOWSELALWAYS, $WS_VSCROLL), BitOR($WS_EX_CLIENTEDGE, $LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT))
			Local $codec_list_handle = GUICtrlGetHandle($codec_list)
			_GUICtrlListView_SetColumnWidth($codec_list_handle, 0, 342 / 2)
			_GUICtrlListView_SetColumnWidth($codec_list_handle, 1, 342 / 2)
			Local $codec_save = GUICtrlCreateButton("Save", 142, 312, 129, 29, $WS_GROUP)
			GUICtrlCreateGroup("", -99, -99, 1, 1)

			$v_codec = _Get_MediaInfo($codec_get_file, "Video;%CodecID%-")
			$v_codecs_string = StringSplit($v_codec, "-")
			For $a = 1 To UBound($v_codecs_string) - 1
				If $v_codecs_string[$a] <> "" And StringInStr(_GUICtrlListView_GetItemText($codec_list_handle, _GUICtrlListView_GetItemCount($codec_list_handle) - 1, 1), $v_codecs_string[$a]) = 0 Then
					Switch $v_codecs_string[$a]
						Case "XVID"
							$v_codecs_string[$a] = "V_MS/VFW/FOURCC, XVID"
					EndSwitch
					GUICtrlCreateListViewItem("|" & $v_codecs_string[$a], $codec_list)
				EndIf
			Next
			$a_codec = _Get_MediaInfo($codec_get_file, "Audio;%CodecID%-")
			$a_codecs_string = StringSplit($a_codec, "-")
			For $a = 1 To UBound($a_codecs_string) - 1
				If $a_codecs_string[$a] <> "" And StringInStr(_GUICtrlListView_GetItemText($codec_list_handle, _GUICtrlListView_GetItemCount($codec_list_handle) - 1, 1), $a_codecs_string[$a]) = 0 Then
					GUICtrlCreateListViewItem("|" & $a_codecs_string[$a], $codec_list)
				EndIf
			Next
			$s_codec = _Get_MediaInfo($codec_get_file, "Text;%CodecID%-")
			$s_codecs_string = StringSplit($s_codec, "-")
			For $a = 1 To UBound($s_codecs_string) - 1
				If $s_codecs_string[$a] <> "" And StringInStr(_GUICtrlListView_GetItemText($codec_list_handle, _GUICtrlListView_GetItemCount($codec_list_handle) - 1, 1), $s_codecs_string[$a]) = 0 Then
					GUICtrlCreateListViewItem("|" & $s_codecs_string[$a], $codec_list)
				EndIf
			Next
			GUISetState(@SW_SHOW)
			GUISetState(@SW_DISABLE, $GUI)
			While 1
				$nMsg = GUIGetMsg()
				Select
					Case _GUICtrlListView_GetEditControl($codec_list_handle) <> 0
						$item = _GUICtrlListView_GetSelectedIndices($codec_list_handle, True)
						$new_ext = _GUICtrlEdit_GetText(ControlGetHandle("[ACTIVE]", "", ControlGetFocus("[ACTIVE]")))
						If StringMid($new_ext, 1, 1) <> "." And $new_ext <> "" Then $new_ext = "." & $new_ext
						If Not StringIsAlNum(StringMid($new_ext, 2, StringLen($new_ext) - 1)) And $new_ext <> "" And $new_ext <> "." Then
							MsgBox(48, "Error", "Extension can only contain alphanumeric characters A-Z and 0-9.")
							ContinueLoop
						EndIf
						_GUICtrlListView_SetItemText($codec_list_handle, $item[1], $new_ext)
					Case _IsPressed("0D")
						Sleep(100)
						If _GUICtrlListView_GetEditControl($codec_list_handle) = 0 And $z = 0 Then
							$item = _GUICtrlListView_GetSelectedIndices($codec_list_handle, True)
							_GUICtrlListView_EditLabel($codec_list_handle, $item[1])
							$z = 1
						Else
							$z = 0
						EndIf
					Case _IsPressed("71")
						Sleep(100)
						If _GUICtrlListView_GetEditControl($codec_list_handle) = 0 And $z = 0 Then
							$item = _GUICtrlListView_GetSelectedIndices($codec_list_handle, True)
							_GUICtrlListView_EditLabel($codec_list_handle, $item[1])
							$z = 1
						EndIf
					Case $nMsg = $GUI_EVENT_CLOSE
						GUISetState(@SW_ENABLE, $GUI)
						GUIDelete($codec_get_gui)
						ExitLoop
					Case $nMsg = $codec_save
						For $a = 0 To _GUICtrlListView_GetItemCount($codec_list_handle) - 1
							If _GUICtrlListView_GetItemText($codec_list_handle, $a) <> "" Then
								IniWriteSection(@ScriptDir & "\custom.ini", _GUICtrlListView_GetItemText($codec_list_handle, $a, 1), "extension=" & _GUICtrlListView_GetItemText($codec_list_handle, $a))
							EndIf
						Next
						GUISetState(@SW_ENABLE, $GUI)
						GUIDelete($codec_get_gui)
						ExitLoop
				EndSelect
			WEnd
		Case $ext_edit
			GUISetState(@SW_DISABLE, $GUI)
			Local $ext_manage_gui = GUICreate("Extension Editor", 317, 157, -1, -1, -1)
			Local $ext_group = GUICtrlCreateGroup("Edit Extensions", 7, 10, 303, 131)
			GUICtrlSetColor(-1, 0x0000FF)
			Local $codec_id = GUICtrlCreateCombo("", 21, 53, 130, 25)
			Local $ext = GUICtrlCreateCombo("", 169, 53, 130, 25)
			Local $save_ext = GUICtrlCreateButton("Save", 33, 93, 90, 26, $WS_GROUP)
			Local $codec_lab = GUICtrlCreateLabel("Codec", 21, 33, 35, 17)
			GUICtrlSetColor(-1, 0x0000FF)
			Local $ext_lab = GUICtrlCreateLabel("Extension", 169, 33, 50, 17)
			GUICtrlSetColor(-1, 0x0000FF)
			Local $ext_del = GUICtrlCreateButton("Delete", 193, 93, 90, 26, $WS_GROUP)
			Local $codec_array = IniReadSectionNames(@ScriptDir & "\custom.ini")
			For $a = 1 To UBound($codec_array) - 1
				$ext_list_item = IniRead(@ScriptDir & "\custom.ini", $codec_array[$a], "extension", "")
				If $ext_list_item <> "" Then
					_GUICtrlComboBox_AddString(GUICtrlGetHandle($codec_id), $codec_array[$a])
					_GUICtrlComboBox_AddString(GUICtrlGetHandle($ext), $ext_list_item)
				EndIf
			Next
			GUISetState(@SW_SHOW)
			Local $hcodec_id = GUICtrlGetHandle($codec_id)
			Local $hext = GUICtrlGetHandle($ext)

			While 1
				$curr_codec = _GUICtrlComboBox_GetCurSel($hcodec_id)
				If $curr_codec <> $last_codec And $curr_codec <> -1 Then
					_GUICtrlComboBox_SetCurSel($hext, $curr_codec)
				EndIf
				$last_codec = $curr_codec
				$curr_ext = _GUICtrlComboBox_GetCurSel($hext)
				If $curr_ext <> $last_ext And $curr_ext <> -1 Then
					_GUICtrlComboBox_SetCurSel($hcodec_id, $curr_ext)
				EndIf
				$last_ext = $curr_ext
				$nMsg = GUIGetMsg()
				Switch $nMsg
					Case $GUI_EVENT_CLOSE
						GUISetState(@SW_ENABLE, $GUI)
						GUIDelete($ext_manage_gui)
						ExitLoop
					Case $save_ext
						Local $new_codec = _GUICtrlComboBox_GetEditText($hcodec_id)
						Local $new_ext = _GUICtrlComboBox_GetEditText($hext)
						If StringMid($new_ext, 1, 1) <> "." Then
							$new_ext = "." & $new_ext
						EndIf
						$find = _GUICtrlComboBox_FindString($hcodec_id, $new_codec)
						If $find = -1 Then
							_GUICtrlComboBox_AddString($hcodec_id, $new_codec)
							_GUICtrlComboBox_AddString($hext, $new_ext)
							_GUICtrlComboBox_SetEditText($hext, $new_ext)
						Else
							_GUICtrlComboBox_SetEditText($hext, $new_ext)
							_GUICtrlComboBox_DeleteString($hext, _GUICtrlComboBox_GetCurSel($hcodec_id))
							_GUICtrlComboBox_InsertString($hext, _GUICtrlComboBox_GetEditText($hext), _GUICtrlComboBox_GetCurSel($hcodec_id))
						EndIf
						IniWriteSection(@ScriptDir & "\custom.ini", $new_codec, "extension=" & $new_ext)
					Case $ext_del
						IniDelete(@ScriptDir & "\custom.ini", _GUICtrlComboBox_GetEditText($hcodec_id))
						_GUICtrlComboBox_DeleteString($hcodec_id, _GUICtrlComboBox_GetCurSel($hcodec_id))
						_GUICtrlComboBox_DeleteString($hext, _GUICtrlComboBox_GetCurSel($hext))
				EndSwitch
			WEnd
		Case $go
			$destination = GUICtrlRead($save_path_input)
			If StringMid($destination, StringLen($destination), 1) = "\" Then $destination = StringTrimRight($destination, 1)
			If Not FileExists($destination) And $destination <> "" Then
				If DirCreate($destination) = 0 Then
					MsgBox(16, "Error", 'Could not create "Output Directory"' & @CRLF & @CRLF & "Choose another place to save files.")
					ContinueLoop
				EndIf
			EndIf
			If Not FileExists($mkvtlnix_path & "\mkvextract.exe") Or Not FileExists($mkvtlnix_path & "\mkvmerge.exe") Then
				MsgBox(48, "Warning", "Mkvextract.exe and/or Mkvmerge.exe was not found." & @CRLF & @CRLF & "Make sure that the path to the files is correct.")
				GUICtrlSetState($go, $GUI_DISABLE)
				$no_toolnix = 1
				ContinueCase
			EndIf
			GUICtrlSetState($file_list, $GUI_DISABLE)
			GUICtrlSetState($tracklist, $GUI_DISABLE)
			GUICtrlSetState($fn_tr_chk, $GUI_DISABLE)
			GUICtrlSetState($tropt_chk, $GUI_DISABLE)
			GUICtrlSetState($tr_fn_chk, $GUI_DISABLE)
			GUICtrlSetState($save_path_input, $GUI_DISABLE)
			GUICtrlSetState($open_mkvs, $GUI_DISABLE)
			GUICtrlSetState($removemkvs, $GUI_DISABLE)
			GUICtrlSetState($toolnix_path, $GUI_DISABLE)
			GUICtrlSetState($about, $GUI_DISABLE)
			GUICtrlSetState($menu, $GUI_DISABLE)
			GUICtrlSetState($help_menu, $GUI_DISABLE)
			GUICtrlSetState($tools_menu, $GUI_DISABLE)
			GUICtrlSetData($go, "CANCEL")
			$file_total = UBound($path_array) - 1
			$max_v = _ArrayMax($v_max, 1)
			$max_a = _ArrayMax($a_max, 1)
			$max_s = _ArrayMax($s_max, 1)
			$cancel = 0
			Select
				Case _GUICtrlTreeView_GetChecked($tracklist, $timecodes) = True And $no_execute = 0
					$multiplyer = 2
				Case Else
					$multiplyer = 1
			EndSelect
			_GUICtrlTreeView_SelectItem($file_list, _GUICtrlTreeView_GetFirstItem($file_list), $TVGN_FIRSTVISIBLE)
			If FileGetSize(@ScriptDir & "\mkvcleaver_log.txt") >= $max_log_size * 1024 Then FileMove(@ScriptDir & "\mkvcleaver_log.txt", @ScriptDir & "\mkvcleaver_log_" & @MON & @MDAY & @YEAR & @HOUR & @MIN & ".txt")
			$log_file = FileOpen(@ScriptDir & "\mkvcleaver_log.txt", 257)
			FileWrite($log_file, @CRLF & @CRLF & "Extraction started on " & @MON & "/" & @MDAY & "/" & @YEAR & " at " & @HOUR & ":" & @MIN & ":" & @SEC)
			For $a = 1 To $file_total
				$item = _GUICtrlTreeView_GetFirstItem($file_list)
				FileWrite($log_file, @CRLF & "  " & _GUICtrlTreeView_GetText($file_list, $item) & " : " & @CRLF & "    Extracting Items -")
				$child = _GUICtrlTreeView_GetFirstChild($file_list, $item)
				For $b = 1 To _GUICtrlTreeView_GetChildCount($file_list, $item)
					If _GUICtrlTreeView_GetChecked($file_list, $child) Then
						$command = _SaveFile_Make($item, $child)
						$cmd &= $track_db[_ArraySearch($track_db, $child, 1, 0, 0, 1)][1] & ":" & '"' & $command & '" '
						If $cancel = 1 Then
							ExitLoop 2
						EndIf
					EndIf
					$child = _GUICtrlTreeView_GetNextChild($file_list, $child)
				Next
				If $cmd = "" Then
					$tracklist_item = _GUICtrlTreeView_GetFirstItem($tracklist)
					For $c = 1 To _GUICtrlTreeView_GetCount($tracklist) - 5
						If _GUICtrlTreeView_GetChecked($tracklist, $tracklist_item) Then
							$command = _SaveFile_Make($item, "")
							If $cancel = 1 Then
								ExitLoop 2
							EndIf
							If $command <> -1 Then $cmd &= $trackID[0] & ":" & '"' & $command & '" '
						EndIf
						$tracklist_item = _GUICtrlTreeView_GetNext($tracklist, $tracklist_item)
					Next
				EndIf
				$call += 1
				Select
					Case $cmd <> "" And $no_execute = 0
						$full_exec = 1
					Case $cmd <> "" And _GUICtrlTreeView_GetChecked($tracklist, $timecodes) = False And $no_execute = 1
						$full_exec = 1
					Case Else
						$full_exec = 0
				EndSelect
				If $full_exec = 1 Then
					Run(@ComSpec & ' /c mkvextract timecodes_v2 ' & '"' & $full_path & '" ' & $cmd2, $mkvtlnix_path, @SW_HIDE)
					$execute = Run(@ComSpec & ' /c mkvextract tracks ' & '"' & $path_array[_ArraySearch($path_array, _GUICtrlTreeView_GetText($file_list, $item), 1, 0, 0, 1)] & _
							'" ' & $flac_flag & $cmd, $mkvtlnix_path, @SW_HIDE, $STDERR_MERGED)
					If _Statusbar_update() = 0 Then ExitLoop
				EndIf
				$std = ""
				If _GUICtrlTreeView_GetChecked($tracklist, $timecodes) = True And $no_execute = 1 Then
					;Do Nothing
				Else
					_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				EndIf
				If _GUICtrlTreeView_GetChecked($tracklist, $timecodes) Then
					If _SaveFile_Make($item, "timecodes") = 0 Then ExitLoop
					_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				EndIf
				If _GUICtrlTreeView_GetChecked($tracklist, $attachments) Then
					If _SaveFile_Make($item, "attachments") = 0 Then ExitLoop
					_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				EndIf
				If _GUICtrlTreeView_GetChecked($tracklist, $cuesheets) Then
					If _SaveFile_Make($item, "cuesheets") = 0 Then ExitLoop
					_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				EndIf
				If _GUICtrlTreeView_GetChecked($tracklist, $chapters) Then
					If _SaveFile_Make($item, "Chapters") = 0 Then ExitLoop
					_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				EndIf
				If _GUICtrlTreeView_GetChecked($tracklist, $tags) Then
					If _SaveFile_Make($item, "Tags") = 0 Then ExitLoop
					_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				EndIf
				If $h264 <> "" And GUICtrlRead($cntoavi) = $GUI_CHECKED And $no_execute = 0 And $last_error_count = $error_count Then
					_GUICtrlStatusBar_SetText($statusbar, "Converting H264 track to AVI (This might take a long time, please be patient).")
					$fps = _Get_MediaInfo($full_path, "Video;%FrameRate%")
					$h264 = StringSplit($h264, "/")
					For $d = 2 To UBound($h264) - 1
						If _Get_MediaInfo($h264[$d], "General;%FileSize%") > 2147483648 Then
							$file_split = " -s 2000"
						Else
							$file_split = ""
						EndIf
						FileWrite($log_file, @CRLF & "    Converting h264 track to AVI")
						$execute = Run(@ComSpec & " /c avc2avi" & " -f " & $fps & $file_split & " -i " & '"' & $h264[$d] & '"' & " -o " & '"' & StringTrimRight($h264[$d], 5) & ".avi" & '"', @ScriptDir, @SW_HIDE, $STDERR_MERGED)
						If _Statusbar_update() = 0 Then ExitLoop 2
					Next
				EndIf
				_GUICtrlStatusBar_SetText($statusbar, "Progress: --%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
				_ArrayDelete($path_array, 1)
				_ArrayDelete($item_array, 1)
				_ArrayDelete($v_max, 1)
				_ArrayDelete($a_max, 1)
				_ArrayDelete($s_max, 1)
				For $b = 1 To _GUICtrlTreeView_GetChildCount($file_list, $item)
					_ArrayDelete($track_db, 1)
				Next
				_GUICtrlTreeView_Delete($file_list, $item)
				$cmd = ""
				$cmd2 = ""
				$cmd3 = ""
				$continue = 0
				$h264 = ""
				$std_mkvm = ""
				If $error_count > $last_error_count Then
					FileWrite($log_file, @CRLF & "    " & $error_log & @CRLF & "    Extraction failed" & @CRLF)
				ElseIf $warning_count > $last_warning_count Then
					FileWrite($log_file, @CRLF & "    " & $warning_log & @CRLF & "    Check extracted files to see if they are usable" & @CRLF)
				Else
					FileWriteLine($log_file, @CRLF & "    Done" & @CRLF)
				EndIf
				$last_error_count = $error_count
				$last_warning_count = $warning_count
			Next
			If UBound($path_array) < 2 Then
				GUICtrlSetState($removemkvs, $GUI_DISABLE)
				GUICtrlSetState($go, $GUI_DISABLE)
				_GUICtrlTreeView_DeleteAll($tracklist)
				Local $v_max[1], $a_max[1], $s_max[1], $track_db[1][2], $extbt_en[1][2], $item_array[1]
				_GUICtrlStatusBar_SetText($statusbar, "")
				If $sd = 1 Then
					IniWrite(@ScriptDir & "\custom.ini", "Shutdown Menu", "shutdown", 0)
					FileWriteLine($log_file, "Extraction finished on " & @MON & "/" & @MDAY & "/" & @YEAR & " at " & @HOUR & ":" & @MIN & ":" & @SEC & @CRLF & "Shutting computer down")
					Shutdown(29)
					Exit
				ElseIf $sd = 2 Then
					FileWriteLine($log_file, "Extraction finished on " & @MON & "/" & @MDAY & "/" & @YEAR & " at " & @HOUR & ":" & @MIN & ":" & @SEC & @CRLF & "Shutting computer down")
					Shutdown(29)
					Exit
				EndIf
			ElseIf UBound($path_array) > 1 And $max_v <> _ArrayMax($v_max, 1) Or UBound($path_array) > 1 And $max_a <> _ArrayMax($a_max, 1) Or UBound($path_array) > 1 And $max_s <> _ArrayMax($s_max, 1) Then
				_TrackCount_Update()
			EndIf
			GUICtrlSetData($go, "Extract Tracks !")
			GUICtrlSetState($file_list, $GUI_ENABLE)
			GUICtrlSetState($tracklist, $GUI_ENABLE)
			GUICtrlSetState($fn_tr_chk, $GUI_ENABLE)
			GUICtrlSetState($tropt_chk, $GUI_ENABLE)
			GUICtrlSetState($tr_fn_chk, $GUI_ENABLE)
			GUICtrlSetState($save_path_input, $GUI_ENABLE)
			GUICtrlSetState($open_mkvs, $GUI_ENABLE)
			GUICtrlSetState($removemkvs, $GUI_ENABLE)
			GUICtrlSetState($toolnix_path, $GUI_ENABLE)
			GUICtrlSetState($about, $GUI_ENABLE)
			GUICtrlSetState($menu, $GUI_ENABLE)
			GUICtrlSetState($help_menu, $GUI_ENABLE)
			GUICtrlSetState($tools_menu, $GUI_ENABLE)
			$cmd = ""
			$cmd2 = ""
			$cmd3 = ""
			$call = 0
			$continue = 0
			$h264 = ""
			$std_mkvm = ""
			If _ArraySearch($item_array, "True", 1, 0, 0, 0, 1) <> -1 And GUICtrlGetState($removemkvs) <> $GUI_ENABLE Then
				GUICtrlSetState($removemkvs, $GUI_ENABLE)
			ElseIf _ArraySearch($item_array, "True", 1, 0, 0, 0, 1) = -1 And GUICtrlGetState($removemkvs) <> $GUI_DISABLE Then
				GUICtrlSetState($removemkvs, $GUI_DISABLE)
			EndIf
			Dim $extbt_en[1][2]
			For $a = 1 To UBound($track_db) - 1
				If _GUICtrlTreeView_GetChecked($file_list, $track_db[$a][0]) Then
					ReDim $extbt_en[UBound($extbt_en) + 1][2]
					$extbt_en[UBound($extbt_en) - 1][0] = $nMsg_handle
					$extbt_en[UBound($extbt_en) - 1][1] = "True"
				EndIf
			Next
			If _GUICtrlStatusBar_GetText($statusbar, 0) <> "Extraction was cancelled by user." Then
				If $error_count = 0 And $warning_count = 0 Then
					_GUICtrlStatusBar_SetText($statusbar, "Extraction finished successfully.")
					FileWriteLine($log_file, "Extraction finished on " & @MON & "/" & @MDAY & "/" & @YEAR & " at " & @HOUR & ":" & @MIN & ":" & @SEC)
				Else
					_GUICtrlStatusBar_SetText($statusbar, "Errors and/or Warnings were encountered.")
					FileWriteLine($log_file, "Extraction finished on " & @MON & "/" & @MDAY & "/" & @YEAR & " at " & @HOUR & ":" & @MIN & ":" & @SEC)
				EndIf
			Else
				If $error_count > $last_error_count Then
					FileWrite($log_file, @CRLF & "    " & $error_log & @CRLF & "    Extraction failed")
				ElseIf $warning_count > $last_warning_count Then
					FileWrite($log_file, @CRLF & "    " & $warning_log & @CRLF & "    Check extracted files to see if they are usable")
				EndIf
				FileWriteLine($log_file, @CRLF & "Extraction was cancelled by user")
			EndIf
			If $error_count > 0 Then MsgBox(16, "Error", "Errors were encountered while extracting tracks." & @CRLF & @CRLF & "See log file for details.")
			If $warning_count > 0 Then MsgBox(48, "Warning", "Warnings were encountered while extracting tracks." & @CRLF & @CRLF & "See log file for details.")
			FileClose($log_file)
			$error_count = 0
			$warning_count = 0
			$last_error_count = 0
			$last_warning_count = 0
		Case $GUI_EVENT_MAXIMIZE
			$maximize = 1
		Case $GUI_EVENT_RESTORE
			$maximize = 0
		Case $lang_on
			$lng_opt = 1
			IniWrite(@ScriptDir & "\custom.ini", "Files", "language", $lng_opt)
		Case $lang_off
			$lng_opt = 0
			IniWrite(@ScriptDir & "\custom.ini", "Files", "language", $lng_opt)
		Case $GUI_EVENT_SECONDARYDOWN
			If $timer = 0 Then
				$timer = _Timer_Init()
				ContinueLoop
			Else
				$timediff = _Timer_Diff($timer)
			EndIf
			If $timediff <= 400 Then
				$cursor = GUIGetCursorInfo($GUI)
				If $cursor[4] = $file_list Then
					$detect_item = _GUICtrlTreeView_HitTestItem($file_list, MouseGetPos(0) - 18, MouseGetPos(1) - 48)
					If $detect_item <> 0 Then
						$selection_text = _GUICtrlTreeView_GetText($file_list, $detect_item)
						$index = _ArraySearch($path_array, $selection_text, 1, 0, 0, 1)
						If $index = -1 Then ContinueLoop
						GUICtrlSetData($info_edit, _Get_MediaInfo($path_array[$index], "info"))
						Sleep(200)
						GUICtrlSetState($info_edit, $GUI_SHOW)
						GUICtrlSetState($file_list, $GUI_DISABLE)
						Do
							If GUIGetMsg() = $GUI_EVENT_CLOSE Then Exit
						Until _IsPressed("1B") Or _IsPressed("02")
						GUICtrlSetState($file_list, $GUI_ENABLE)
						GUICtrlSetState($info_edit, $GUI_HIDE)
						_GUICtrlTreeView_SelectItem($file_list, $detect_item, $TVGN_CARET)
						$timer = 0
						_Timer_KillTimer($GUI, $timer)
					EndIf
				EndIf
			EndIf
		Case Else
			$nMsg_handle = GUICtrlGetHandle($nMsg[0])
			For $a = 1 To UBound($item_array) - 1
				If $item_array[$a][0] = $nMsg[0] Then
					$item_array[$a][1] = _GUICtrlTreeView_GetChecked($file_list, GUICtrlGetHandle($item_array[$a][0]))
					If _ArraySearch($item_array, "True", 1, 0, 0, 0, 1) <> -1 And GUICtrlGetState($removemkvs) <> $GUI_ENABLE Then
						GUICtrlSetState($removemkvs, $GUI_ENABLE)
						ExitLoop
					ElseIf _ArraySearch($item_array, "True", 1, 0, 0, 0, 1) = -1 And GUICtrlGetState($removemkvs) <> $GUI_DISABLE Then
						GUICtrlSetState($removemkvs, $GUI_DISABLE)
						ExitLoop
					EndIf
				EndIf
			Next
			$button_state = GUICtrlGetState($go)
			For $a = 1 To UBound($batch_item_db) - 1
				If $batch_item_db[$a][0] <> $timecodes Then $batch_item_db[$a][1] = _GUICtrlTreeView_GetChecked($tracklist, $batch_item_db[$a][0])
			Next
			$array_search2 = _ArraySearch($batch_item_db, "True", 1, 0, 0, 0, 1)
			If _GUICtrlTreeView_GetChecked($file_list, $nMsg_handle) And _ArraySearch($extbt_en, $nMsg_handle, 1) = -1 And _ArraySearch($track_db, $nMsg_handle, 1) <> -1 Then
				ReDim $extbt_en[UBound($extbt_en) + 1][2]
				$extbt_en[UBound($extbt_en) - 1][0] = $nMsg_handle
				$extbt_en[UBound($extbt_en) - 1][1] = "True"
			ElseIf Not _GUICtrlTreeView_GetChecked($file_list, $nMsg_handle) And _ArraySearch($extbt_en, $nMsg_handle, 1) <> -1 And $nMsg_handle <> 0 Then
				_ArrayDelete($extbt_en, _ArraySearch($extbt_en, $nMsg_handle, 1))
			EndIf
			$array_search1 = _ArraySearch($extbt_en, "True", 1, 0, 0, 0, 1)
			If $array_search1 <> -1 Or $array_search2 <> -1 Then
				$true = 1
			ElseIf $array_search1 = -1 And $array_search2 = -1 Then
				$true = 0
			EndIf
			Select
				Case $true = 1 And $button_state <> 80 And $mkvtlnix_path <> "" And $no_toolnix = 0
					GUICtrlSetState($go, $GUI_ENABLE)
				Case $true = 0 And $button_state <> 144
					GUICtrlSetState($go, $GUI_DISABLE)
			EndSelect
	EndSwitch
WEnd

Func OnAutoItExit()
	DllCall($media_info_dll, "none", "MediaInfo_Delete", "ptr", $media_info_handle[0])
	DllClose($media_info_dll)
	$position = WinGetPos("MKVcleaver " & FileGetVersion(@AutoItExe))
	IniWriteSection(@ScriptDir & "\custom.ini", "GUI", "x=" & $position[0] & @LF & "y=" & $position[1] & @LF & "width=" & $position[2] & @LF & "hight=" & $position[3] & @LF & "resize=" & $resize_bit & @LF & "maximized=" & $maximize)
EndFunc   ;==>OnAutoItExit

Func _Get_MediaInfo($path, $info_type)
	Select
		Case $info_type = "info"
			DllCall($media_info_dll, "none", "MediaInfo_Delete", "ptr", $media_info_handle[0])
			DllClose($media_info_dll)
			$media_info_dll = DllOpen(@ScriptDir & "\MediaInfo_x64.dll")
			$media_info_handle = DllCall($media_info_dll, "ptr", "MediaInfo_New")
			DllCall($media_info_dll, "int", "MediaInfo_Open", "ptr", $media_info_handle[0], "wstr", $path)
			DllCall($media_info_dll, "wstr", "MediaInfo_Option", "ptr", 0, "wstr", "Complete", "wstr", "")
			$return = DllCall($media_info_dll, "wstr", "MediaInfo_Inform", "ptr", $media_info_handle[0], "int", 0)
			Return $return[0]
		Case $info_type = "language"
			DllCall($media_info_dll, "int", "MediaInfo_Open", "ptr", $media_info_handle[0], "wstr", $path)
			If $track_type[0] = "audio" Then
				$return = DllCall($media_info_dll, "wstr", "MediaInfo_Get", "ptr", $media_info_handle[0], "int", 2, "int", $track_num - 1, "wstr", "Language", "int", 1, "int", 0)
			ElseIf $track_type[0] = "subtitles" Then
				$return = DllCall($media_info_dll, "wstr", "MediaInfo_Get", "ptr", $media_info_handle[0], "int", 3, "int", $track_num - 1, "wstr", "Language", "int", 1, "int", 0)
			EndIf
			Return $return[0]
	EndSelect
	DllCall($media_info_dll, "none", "MediaInfo_Delete", "ptr", $media_info_handle[0])
	$media_info_handle = DllCall($media_info_dll, "ptr", "MediaInfo_New")
	DllCall($media_info_dll, "int", "MediaInfo_Open", "ptr", $media_info_handle[0], "wstr", $path)
	DllCall($media_info_dll, "wstr", "MediaInfo_Option", "ptr", 0, "wstr", "Inform", "wstr", $info_type)
	$return = DllCall($media_info_dll, "wstr", "MediaInfo_Inform", "ptr", $media_info_handle[0], "int", 0)
	Return $return[0]
EndFunc   ;==>_Get_MediaInfo

Func SelectAll()
	$file = _GUICtrlTreeView_GetFirstItem($file_list)
	If $all_checked = 0 Then
		For $a = 1 To UBound($path_array) - 1
			_GUICtrlTreeView_SetChecked($file_list, $file, True)
			$file = _GUICtrlTreeView_GetNextSibling($file_list, $file)
		Next
		$all_checked = 1
		GUICtrlSetState($removemkvs, $GUI_ENABLE)
		For $a = 1 To UBound($item_array) - 1
			$item_array[$a][1] = "True"
		Next
	Else
		For $a = 1 To UBound($path_array) - 1
			_GUICtrlTreeView_SetChecked($file_list, $file, False)
			$file = _GUICtrlTreeView_GetNextSibling($file_list, $file)
		Next
		$all_checked = 0
		GUICtrlSetState($removemkvs, $GUI_DISABLE)
		For $a = 1 To UBound($item_array) - 1
			$item_array[$a][1] = "Fasle"
		Next
	EndIf
EndFunc   ;==>SelectAll

Func _SaveFile_Make($itemID, $childID)
	$file_name = _GUICtrlTreeView_GetText($file_list, $itemID)
	$full_path = $path_array[_ArraySearch($path_array, $file_name, 1, 0, 0, 1)]
	If $childID <> "cuesheets" And $childID <> "tags" And $childID <> "chapters" And $std_mkvm = "" Then
		$identify = Run(@ComSpec & " /c mkvmerge --ui-language en -i " & '"' & $full_path & '"', $mkvtlnix_path, @SW_HIDE, $STDERR_MERGED)
		Do
			$std_mkvm &= StdoutRead($identify)
		Until @error
		If $std_mkvm = "" Then
			MsgBox(16, "Error", "Could not get information from Mkvmerge.exe" & @CRLF & @CRLF & "Download and install the latest version of MkvToolNix.")
			$cancel = 1
			Return
		EndIf
		$identify_split = StringSplit(StringStripCR($std_mkvm), @CRLF)
	EndIf
	Select
		Case $childID = "attachments"
			$sbText = _GUICtrlStatusBar_GetText($statusbar, 0)
			_GUICtrlStatusBar_SetText($statusbar, $sbText & " | Extracting Attachments...")
			$match = _ArrayFindAll($identify_split, "Attachment", 2, 0, 0, 1)
			If $match = -1 Then Return 1
			If $destination = "" Then
				$path_split = _PathSplit($full_path, $szDrive, $szDir, $szFName, $szExt)
				$extract_path = $szDrive & $szDir
			Else
				$extract_path = $destination & "\"
			EndIf
			For $b = 0 To UBound($match) - 1
				$attachID = _StringBetween($identify_split[$match[$b]], "Attachment ID ", ":")
				$attach_filename = _StringBetween($identify_split[$match[$b]], "file name '", "'")
				$extention_get = StringSplit($file_name, ".")
				$extract_attachments &= $attachID[0] & ":" & '"' & $extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_Attachments\" & $attach_filename[0] & '" '
			Next
			$execute = Run(@ComSpec & " /c mkvextract attachments " & '"' & $full_path & '" ' & $extract_attachments, $mkvtlnix_path, @SW_HIDE, $STDERR_MERGED)
			$return = _Statusbar_update()
			$extract_attachments = ""
			FileWrite($log_file, " attachments")
			Return $return
		Case $childID = "cuesheets"
			$sbText = _GUICtrlStatusBar_GetText($statusbar, 0)
			_GUICtrlStatusBar_SetText($statusbar, $sbText & " | Extracting Cuesheets...")
			If $destination = "" Then
				$path_split = _PathSplit($full_path, $szDrive, $szDir, $szFName, $szExt)
				$extract_path = $szDrive & $szDir
			Else
				$extract_path = $destination & "\"
			EndIf
			$extention_get = StringSplit($file_name, ".")
			$execute = Run(@ComSpec & " /c mkvextract cuesheet " & '"' & $full_path & '" > ' & '"' & $extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_Cuesheet.cue" & '"', $mkvtlnix_path, @SW_HIDE, $STDERR_MERGED)
			$return = _Statusbar_update()
			If FileRead($extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_Cuesheet.cue") = "" Then
				FileDelete($extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_Cuesheet.cue")
			Else
				FileWrite($log_file, " cuesheets")
			EndIf
			Return $return
		Case $childID = "chapters" Or $childID = "tags"
			$sbText = _GUICtrlStatusBar_GetText($statusbar, 0)
			_GUICtrlStatusBar_SetText($statusbar, $sbText & " | Extracting " & $childID & "...")
			If $destination = "" Then
				$path_split = _PathSplit($full_path, $szDrive, $szDir, $szFName, $szExt)
				$extract_path = $szDrive & $szDir
			Else
				$extract_path = $destination & "\"
			EndIf
			$extention_get = StringSplit($file_name, ".")
			$execute = Run(@ComSpec & " /c mkvextract " & StringLower($childID) & ' "' & $full_path & '" > ' & '"' & $extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_" & $childID & ".xml" & '"', $mkvtlnix_path, @SW_HIDE, $STDERR_MERGED)
			$return = _Statusbar_update()
			If FileRead($extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_" & $childID & ".xml") = "" Then
				FileDelete($extract_path & StringTrimRight($file_name, StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_" & $childID & ".xml")
			Else
				FileWrite($log_file, " " & $childID)
			EndIf
			Return $return
		Case $childID = "timecodes"
			If $cmd = "" And $continue = 1 Then $call += 1
			If $cmd <> "" Then
				$split_command = StringSplit($cmd, '" ', 1)
				For $b = 1 To UBound($split_command) - 2
					$extention_get = StringSplit($split_command[$b], ".")
					$cmd3 &= StringTrimRight($split_command[$b], StringLen($extention_get[UBound($extention_get) - 1]) + 1) & "_Timecodes.txt" & '" '
				Next
				$execute = Run(@ComSpec & " /c mkvextract timecodes_v2 " & '"' & $full_path & '" ' & $cmd3, $mkvtlnix_path, @SW_HIDE, $STDERR_MERGED)
				If $no_execute = 0 Then $call += 1
				$return = _Statusbar_update()
				FileWrite($log_file, " timecodes")
				Return $return
			ElseIf $cmd = "" And $continue = 0 Then
				MsgBox(48, "Selection error", '"Timecodes" cannot be checked by itself.' & @CRLF & @CRLF & "You must select at least one track to get timecodes from.")
				_GUICtrlStatusBar_SetText($statusbar, "")
				FileWrite($log_file, @CRLF & '    "Timecodes" box cannot be checked by itself. Select a track to get timecodes from.' & @CRLF)
				$error_count += 1
				Return 0
			EndIf
			Return 1
		Case $childID <> ""
			$track_index = _ArraySearch($identify_split, "Track ID " & $track_db[_ArraySearch($track_db, $childID)][1], 2, 0, 0, 1)
			$codec_id = _StringBetween($identify_split[$track_index], "(", ")")
			$track_type = _StringBetween($identify_split[$track_index], ": ", " (")
			$trackID[0] = $track_db[_ArraySearch($track_db, $childID)][1]
			$match = _ArrayFindAll($identify_split, $track_type[0], 2, 0, 0, 1)
			$track_num = _ArraySearch($match, $track_index) + 1
		Case Else
			$batch_item_split = StringSplit(_GUICtrlTreeView_GetText($tracklist, $tracklist_item), " ")
			$match = _ArrayFindAll($identify_split, $batch_item_split[1], 2, 0, 0, 1)
			If UBound($match) < $batch_item_split[3] Then
				$continue = 1
				Return -1
			EndIf
			$codec_id = _StringBetween($identify_split[$match[$batch_item_split[3] - 1]], "(", ")")
			$track_type = _StringBetween($identify_split[$match[$batch_item_split[3] - 1]], ": ", " (")
			$trackID = _StringBetween($identify_split[$match[$batch_item_split[3] - 1]], "Track ID ", ":")
			$track_num = $batch_item_split[3]
	EndSelect
	FileWrite($log_file, " " & $track_type[0])
	$custom_extension = IniReadSectionNames(@ScriptDir & "\custom.ini")
	$find = _ArraySearch($custom_extension, $codec_id[0])
	Select
		Case $find <> -1
			$output = IniRead(@ScriptDir & "\custom.ini", $custom_extension[$find], "extension", ".undefined")
		Case StringInStr($codec_id[0], "V_REAL/")
			$output = ".rm"
		Case $codec_id[0] = "V_MPEG1"
			$output = ".m1v"
		Case $codec_id[0] = "V_MPEG2"
			$output = ".m2v"
		Case $codec_id[0] = "V_THEORA"
			$output = ".ogm"
		Case $codec_id[0] = "V_MPEG4/ISO/AVC"
			$output = ".h264"
		Case StringInStr($codec_id[0], "V_MS/VFW/FOURCC") Or $codec_id[0] = "V_SNOW" Or StringInStr($codec_id[0], "V_MPEG4/ISO/") Or $codec_id[0] = "V_UNCOMPRESSED" Or $codec_id[0] = "V_MPEG4/MS/V3"
			$output = ".avi"
		Case $codec_id[0] = "V_QUICKTIME"
			$output = ".mov"
		Case $codec_id[0] = "V_VP8"
			$output = ".ivf"
		Case $codec_id[0] = "A_MPEG/L3"
			$output = ".mp3"
		Case $codec_id[0] = "A_MPEG/L2"
			$output = ".mp2"
		Case $codec_id[0] = "A_MPEG/L1"
			$output = ".mp1"
		Case StringInStr($codec_id[0], "A_PCM")
			$output = ".wav"
		Case StringInStr($codec_id[0], "A_AC3")
			$output = ".ac3"
		Case $codec_id[0] = "A_DTS"
			$output = ".dts"
		Case $codec_id[0] = "A_FLAC" And $flac = 1 Or $codec_id[0] = "A_FLAC" And StringMid($mkvex_version, 1, 1) >= 4
			$output = ".flac"
		Case $codec_id[0] = "A_VORBIS" Or $codec_id[0] = "S_KATE" Or $codec_id[0] = "A_FLAC"
			$output = ".ogg"
		Case StringInStr($codec_id[0], "A_REAL/")
			$output = ".ra"
		Case $codec_id[0] = "A_MS/ACM"
			$output = ".acm"
		Case StringInStr($codec_id[0], "A_AAC") Or $codec_id[0] = "A_QUICKTIME"
			$output = ".aac"
		Case $codec_id[0] = "A_TTA1"
			$output = ".tta"
		Case $codec_id[0] = "A_WAVPACK4"
			$output = ".wv"
		Case $codec_id[0] = "A_TRUEHD"
			$output = ".truehd"
		Case $codec_id[0] = "S_TEXT/ASCII" Or $codec_id[0] = "S_TEXT/UTF8"
			$output = ".srt"
		Case $codec_id[0] = "S_TEXT/SSA"
			$output = ".ssa"
		Case $codec_id[0] = "S_TEXT/ASS"
			$output = ".ass"
		Case $codec_id[0] = "S_TEXT/USF"
			$output = ".usf"
		Case $codec_id[0] = "S_VOBSUB"
			$output = ".idx"
		Case $codec_id[0] = "S_HDMV/PGS"
			$output = "_PGS.sup"
		Case Else
			$output = ".unknown"
	EndSelect
	If $track_type[0] = "audio" And $lng_opt = 1 Or $track_type[0] = "subtitles" And $lng_opt = 1 Then
		$lng = StringUpper(_Get_MediaInfo($full_path, "language"))
		If $lng <> "" Then $lng = "(" & $lng & ")"
	Else
		$lng = ""
	EndIf
	If $destination = "" Then
		Select
			Case GUICtrlRead($tr_fn_chk) = $GUI_CHECKED
				$path_split = _PathSplit($full_path, $szDrive, $szDir, $szFName, $szExt)
				$command_path = _PathMake($szDrive, $szDir, "Track" & $trackID[0] & "_" & $szFName & $lng, $output)
				If $track_type[0] = "video" Then
					_CheckVFR($szDrive & "\" & $szDir & "\Track" & $trackID[0] & "_" & $szFName)
					If $codec_id[0] = "V_MPEG4/ISO/AVC" Then $h264 &= "/" & $command_path
				EndIf
				Return $command_path
			Case GUICtrlRead($fn_tr_chk) = $GUI_CHECKED And GUICtrlRead($tropt_chk) = $GUI_UNCHECKED
				$path_split = _PathSplit($full_path, $szDrive, $szDir, $szFName, $szExt)
				$command_path = _PathMake($szDrive, $szDir, $szFName & "_Track" & $trackID[0] & $lng, $output)
				If $track_type[0] = "video" Then
					_CheckVFR($szDrive & "\" & $szDir & "\" & $szFName & "_Track" & $trackID[0])
					If $codec_id[0] = "V_MPEG4/ISO/AVC" Then $h264 &= "/" & $command_path
				EndIf
				Return $command_path
			Case GUICtrlRead($fn_tr_chk) = $GUI_CHECKED And GUICtrlRead($tropt_chk) = $GUI_CHECKED
				$path_split = _PathSplit($full_path, $szDrive, $szDir, $szFName, $szExt)
				$command_path = _PathMake($szDrive, $szDir, $szFName & _StringProper("_" & $track_type[0]) & $track_num & $lng, $output)
				If $track_type[0] = "video" Then
					_CheckVFR($szDrive & "\" & $szDir & "\" & $szFName & _StringProper("_" & $track_type[0]) & $track_num)
					If $codec_id[0] = "V_MPEG4/ISO/AVC" Then $h264 &= "/" & $command_path
				EndIf
				Return $command_path
		EndSelect
	Else
		Select
			Case GUICtrlRead($tr_fn_chk) = $GUI_CHECKED
				$command_path = $destination & "\" & "Track" & $trackID[0] & "_" & StringTrimRight($file_name, 4) & $lng & $output
				If $track_type[0] = "video" Then
					_CheckVFR($destination & "\" & "Track" & $trackID[0] & "_" & StringTrimRight($file_name, 4))
					If $codec_id[0] = "V_MPEG4/ISO/AVC" Then $h264 &= "/" & $command_path
				EndIf
				Return $command_path
			Case GUICtrlRead($fn_tr_chk) = $GUI_CHECKED And GUICtrlRead($tropt_chk) = $GUI_UNCHECKED
				$command_path = $destination & "\" & StringTrimRight($file_name, 4) & "_Track" & $trackID[0] & $lng & $output
				If $track_type[0] = "video" Then
					_CheckVFR($destination & "\" & StringTrimRight($file_name, 4) & "_Track" & $trackID[0])
					If $codec_id[0] = "V_MPEG4/ISO/AVC" Then $h264 &= "/" & $command_path
				EndIf
				Return $command_path
			Case GUICtrlRead($fn_tr_chk) = $GUI_CHECKED And GUICtrlRead($tropt_chk) = $GUI_CHECKED
				$command_path = $destination & "\" & StringTrimRight($file_name, 4) & _StringProper("_" & $track_type[0]) & $track_num & $lng & $output
				If $track_type[0] = "video" Then
					_CheckVFR($destination & "\" & StringTrimRight($file_name, 4) & _StringProper("_" & $track_type[0]) & $track_num)
					If $codec_id[0] = "V_MPEG4/ISO/AVC" Then $h264 &= "/" & $command_path
				EndIf
				Return $command_path
		EndSelect
	EndIf
EndFunc   ;==>_SaveFile_Make

Func _TrackCount_Update()
	Dim $batch_item_db[1][2]
	_GUICtrlTreeView_DeleteAll($tracklist)
	_GUICtrlTreeView_BeginUpdate($tracklist)
	For $a = 1 To _ArrayMax($v_max, 1)
		ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
		$batch_item_db[UBound($batch_item_db) - 1][0] = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Video Track " & $a, $tracklist))
	Next
	For $a = 1 To _ArrayMax($a_max, 1)
		$atrack = GUICtrlCreateTreeViewItem("Audio Track " & $a, $tracklist)
		ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
		$batch_item_db[UBound($batch_item_db) - 1][0] = GUICtrlGetHandle($atrack)
	Next
	For $a = 1 To _ArrayMax($s_max, 1)
		ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
		$batch_item_db[UBound($batch_item_db) - 1][0] = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Subtitle Track " & $a, $tracklist))
	Next
	$attachments = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Attachments", $tracklist))
	ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
	$batch_item_db[UBound($batch_item_db) - 1][0] = $attachments
	$timecodes_raw = GUICtrlCreateTreeViewItem("Timecodes", $tracklist)
	$timecodes = GUICtrlGetHandle($timecodes_raw)
	ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
	$batch_item_db[UBound($batch_item_db) - 1][0] = $timecodes
	$cuesheets = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Cuesheets", $tracklist))
	ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
	$batch_item_db[UBound($batch_item_db) - 1][0] = $cuesheets
	$chapters = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Chapters", $tracklist))
	ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
	$batch_item_db[UBound($batch_item_db) - 1][0] = $chapters
	$tags = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Tags", $tracklist))
	ReDim $batch_item_db[UBound($batch_item_db) + 1][2]
	$batch_item_db[UBound($batch_item_db) - 1][0] = $tags
	_GUICtrlTreeView_EndUpdate($tracklist)
EndFunc   ;==>_TrackCount_Update

Func _CheckVFR($file_to_check)
	If _GUICtrlTreeView_GetChecked($tracklist, $timecodes) Or $vfr_detect = 0 Then Return
	$sbText = _GUICtrlStatusBar_GetText($statusbar, 0)
	_GUICtrlStatusBar_SetText($statusbar, "Getting Framerate mode... (This might take a while, depending on file size).")
	$execute = Run(@ComSpec & ' /c avdump -w "' & $full_path & '"', @ScriptDir, @SW_HIDE, $STDERR_MERGED)
	Do
		If GUIGetMsg() = $go Then
			Do
				ProcessClose($execute)
			Until Not ProcessExists($execute)
			$process_list = ProcessList()
			$index = _ArraySearch($process_list, "avdump", 1, 0, 0, 1, 1, 0)
			If $index <> -1 Then ProcessClose($process_list[$index][1])
			$std = ""
			_GUICtrlStatusBar_SetText($statusbar, "Extraction was cancelled by user.")
			$cancel = 1
			Return
		EndIf
		$std &= StdoutRead($execute)
	Until @error
	$avdump_split = StringSplit(StringStripCR($std), @LF)
	If StringInStr($avdump_split[Pos_Convert(_ArraySearch($avdump_split, "fram:", 2, 0, 0, 1))], "vfr") Then
		$cmd2 &= $trackID[0] & ":" & $file_to_check & "_Timecodes.txt "
		FileWrite($log_file, "(vfr)")
	ElseIf $std <> "" Then
		FileWrite($log_file, "(cfr)")
	Else
		FileWrite($log_file, "(n/a)")
	EndIf
	$std = ""
EndFunc   ;==>_CheckVFR

Func _Statusbar_update()
	Do
		If $std <> "" Then
			$std_split = StringSplit($std, @CRLF)
			$clean = _ArrayFindAll($std_split, "")
			For $z = 0 To UBound($clean) - 1
				_ArrayDelete($std_split, $clean[$z])
			Next
			$curr_percent = _StringBetween(StringStripCR($std_split[UBound($std_split) - 1]), "Progress: ", "%")
			If $curr_percent <> 0 Then
				_GUICtrlStatusBar_SetText($statusbar, "Progress: " & $curr_percent[0] & "%" & " | Overall Progress: " & Int((100 / ($file_total * $multiplyer)) * ($curr_percent[0] / 100) + (100 / ($file_total * $multiplyer)) * ($call - 1)) & "%")
			EndIf
			$find_error = _ArraySearch($std_split, "Error:", 1, 0, 0, 1)
			If $find_error <> -1 Then
				$error_count += 1
				$error_log = $std_split[$find_error]
				FileWrite($log_file, "(error)")
			EndIf
			$find_warning = _ArraySearch($std_split, "Warning:", 1, 0, 0, 1)
			If $find_warning <> -1 Then
				$warning_count += 1
				$warning_log = $std_split[$find_warning]
				FileWrite($log_file, "(warning)")
			EndIf
		EndIf
		If GUIGetMsg() = $go Then
			Do
				ProcessClose($execute)
			Until Not ProcessExists($execute)
			Do
				Sleep(100)
				$process_list = ProcessList()
				$index = _ArraySearch($process_list, "mkvextract", 1, 0, 0, 1, 1, 0)
				ProcessClose($process_list[Pos_Convert($index)][1])
			Until $index = -1
			$index = _ArraySearch($process_list, "avc2avi", 1, 0, 0, 1, 1, 0)
			If $index <> -1 Then ProcessClose($process_list[$index][1])
			$std = ""
			_GUICtrlStatusBar_SetText($statusbar, "Extraction was cancelled by user.")
			$cancel = 1
			Return 0
		EndIf
		$std = StdoutRead($execute)
	Until @error
	$std = ""
	Return 1
EndFunc   ;==>_Statusbar_update

Func WM_DROPFILES($hWnd, $msgID, $wParam, $lParam)
	Local $nSize, $pFileName
	Local $nAmt = DllCall("shell32.dll", "int", "DragQueryFileW", "hwnd", $wParam, "uint", 0xFFFFFFFF, "ptr", 0, "uint", 255)
	$aDroppedFiles = 0
	Dim $aDroppedFiles[$nAmt[0] + 1]
	For $i = 0 To $nAmt[0] - 1
		$nSize = DllCall("shell32.dll", "int", "DragQueryFileW", "hwnd", $wParam, "uint", $i, "ptr", 0, "uint", 0)
		$nSize = $nSize[0] + 1
		$pFileName = DllStructCreate("wchar[" & $nSize & "]")
		DllCall("shell32.dll", "int", "DragQueryFileW", "hwnd", $wParam, "uint", $i, "ptr", DllStructGetPtr($pFileName), "uint", $nSize)
		$aDroppedFiles[0] += 1
		$aDroppedFiles[$aDroppedFiles[0]] = DllStructGetData($pFileName, 1)
		$pFileName = 0
	Next
	ReDim $aDroppedFiles[$aDroppedFiles[0] + 1]
EndFunc   ;==>WM_DROPFILES

Func stb_resize($hWnd, $iMsg, $iwParam, $ilParam)
	_GUICtrlStatusBar_Resize($statusbar)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>stb_resize

Func Pos_Convert($number)
	If StringInStr($number, "-") Then
		Return 0
	Else
		Return $number
	EndIf
EndFunc   ;==>Pos_Convert

Func Add_Files($files)
	If $files = "" Then Return
	If StringMid($files, 1, 1) = "|" Then $files = StringTrimLeft($files, 1)
	$files = StringSplit($files, "|")
	_ArraySort($files, 0, 1, 0)
	For $z = 1 To UBound($files) - 1
		$split_path = _PathSplit($files[$z], $szDrive, $szDir, $szFName, $szExt)
		If _GUICtrlTreeView_FindItem($file_list, $split_path[3] & $split_path[4]) Then ContinueLoop
		$file_format = _Get_MediaInfo($files[$z], "General;%Format%")
		If Not StringInStr($file_format, "Matroska") Then
			$omit &= $files[$z] & @CRLF
			$omit_count += 1
			ContinueLoop
		EndIf
		_ArrayAdd($path_array, $files[$z])
		$video_count = _Get_MediaInfo($files[$z], "General;%VideoCount%")
		_ArrayAdd($v_max, $video_count)
		$audio_count = _Get_MediaInfo($files[$z], "General;%AudioCount%")
		_ArrayAdd($a_max, $audio_count)
		$subs_count = _Get_MediaInfo($files[$z], "General;%TextCount%")
		_ArrayAdd($s_max, $subs_count)
		$item = GUICtrlCreateTreeViewItem($split_path[3] & $split_path[4], $file_list)
		ReDim $item_array[UBound($item_array) + 1][2]
		$item_array[UBound($item_array) - 1][0] = $item
		$v_codecs_string = _Get_MediaInfo($files[$z], "General;%Video_Format_List%")
		$v_codec = StringSplit($v_codecs_string, " / ", 1)
		$track_id = _Get_MediaInfo($files[$z], "Video;%ID%-")
		$track_id_split = StringSplit($track_id, "-")
		For $a = 1 To $video_count
			ReDim $track_db[UBound($track_db, 1) + 1][2]
			$track_db[UBound($track_db, 1) - 1][0] = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Video Track <" & $v_codec[$a] & "> (" & _Get_MediaInfo($files[$z], "Video;%Duration/String3%") & ")", $item))
			$track_db[UBound($track_db, 1) - 1][1] = $track_id_split[$a]
		Next
		$a_lng_string = _Get_MediaInfo($files[$z], "General;%Audio_Language_List%")
		$lng = StringSplit($a_lng_string, " / ", 1)
		$a_codecs_string = _Get_MediaInfo($files[$z], "General;%Audio_Format_List%")
		$a_codec = StringSplit($a_codecs_string, " / ", 1)
		$track_id = _Get_MediaInfo($files[$z], "Audio;%ID%-")
		$track_id_split = StringSplit($track_id, "-")
		$channel_count = StringSplit(_Get_MediaInfo($files[$z], "Audio;%Channel(s)%-"), "-", 1)
		For $a = 1 To $audio_count
			ReDim $track_db[UBound($track_db, 1) + 1][2]
			If $lng[$a] = "" Then $lng[$a] = "Unknown"
			$track_db[UBound($track_db, 1) - 1][0] = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Audio Track <" & $a_codec[$a] & "> (" & $lng[$a] & " - " & $channel_count[$a] & " channels)", $item))
			$track_db[UBound($track_db, 1) - 1][1] = $track_id_split[$a]
		Next
		$s_lng_String = _Get_MediaInfo($files[$z], "General;%Text_Language_List%")
		$lng = StringSplit($s_lng_String, " / ", 1)
		$s_codecs_string = _Get_MediaInfo($files[$z], "General;%Text_Format_List%")
		$s_codec = StringSplit($s_codecs_string, " / ", 1)
		$track_id = _Get_MediaInfo($files[$z], "Text;%ID%-")
		$track_id_split = StringSplit($track_id, "-")
		For $a = 1 To $subs_count
			ReDim $track_db[UBound($track_db, 1) + 1][2]
			If $lng[$a] = "" Then $lng[$a] = "Unknown"
			$track_db[UBound($track_db, 1) - 1][0] = GUICtrlGetHandle(GUICtrlCreateTreeViewItem("Subtitle Track <" & $s_codec[$a] & "> (" & $lng[$a] & ")", $item))
			$track_db[UBound($track_db, 1) - 1][1] = $track_id_split[$a]
		Next
	Next
	If $omit <> "" Then MsgBox(48, "Note", "The following files were omitted, because they were not recognized as Matroska:" & @CRLF & @CRLF & $omit)
	_GUICtrlTreeView_BeginUpdate($file_list)
	_GUICtrlTreeView_EndUpdate($file_list)
	If $omit_count <> $files[0] Then
		_TrackCount_Update()
	EndIf
	$omit = ""
	$omit_count = 0
EndFunc   ;==>Add_Files

;Func _Source()
;	If Not FileExists(@ScriptDir & "\Source") Then DirCreate(@ScriptDir & "\Source")
;	FileInstall("mkvcleaver_source_x64.au3", @ScriptDir & "\Source\MKVcleaver_source_x64.au3", 1)
;	FileInstall("mkv.ico", @ScriptDir & "\Source\mkv.ico", 1)
;	FileInstall("mkv.bmp", @ScriptDir & "\Source\mkv.bmp", 1)
;	FileInstall("line.bmp", @ScriptDir & "\Source\line.bmp", 1)
;	FileInstall("resources.au3", @ScriptDir & "\Source\resources.au3", 1)
;FileInstall("MediaInfo_x64.dll", @ScriptDir & "\Source\MediaInfo_x64.dll", 1)
;EndFunc   ;==>_Source